/*
 * Config-reader library - copyright (c) dark0n3 - 2002
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

struct stat	config;
char		*config_data	= 0;
char		*config_end	= 0;
char		*branch_begin	= 0;
char		*branch_end	= 0;
char		*return_value	= 0;










int open_config(char *f) {
 FILE		*F;
 
 if ( stat(f, &config) == -1 && config.st_size == 0 ) {
	return -1;
	}

 config_data = malloc(config.st_size + 1);
 config_end = config_data + config.st_size;
 bzero(config_data, config.st_size + 1);

 if ((F = fopen(f, "r")) == NULL) {
	return -1;
	}

 fread(config_data, 1, config.st_size, F);

 fclose(F);
}










void close_config() {
 if ( config_data != 0 ) {
	free(config_data);
	}
 if ( return_value != 0 ) {
	free(return_value);
	}
}










int seek_config_branch(char *b_name) {
 char	*branch_seek;
 char	*line;
 char	*var;
 int	b_len = strlen(b_name);
 
 branch_seek = config_data;
 branch_begin = return_value = 0;

 while ( branch_seek < config_end && branch_begin == 0 ) {
	for ( line = branch_seek ; *branch_seek != '\n' && branch_seek < config_end ; branch_seek++ );
	while ( isspace(*line) && line < branch_seek ) line++;
	if ( *line == '[' ) {
		var = line + 1;
		while ( *line != ']' && line < branch_seek ) line++;
		if ( *line == ']' && b_len == line - var && memcmp(b_name, var, b_len) == 0) {
			while ( isspace(*line) && line < branch_seek ) line++;
			if ( line == branch_seek - 1 && branch_seek + 1 != config_end ) {
				branch_begin = branch_seek + 1;
				}
			}
		}
	branch_seek++;
	}

 if ( branch_begin != 0 ) {
	while ( *branch_seek != '[' && branch_seek < config_end ) branch_seek++;
	branch_end = branch_seek;
	return 0;
	}
 return -1;
}










char *seek_config_key(char *k_name) {
 char	*key_seek;
 char	*line;
 char	*var;
 int	k_len = strlen(k_name);
 int	r_len;

 key_seek = branch_begin;

 if ( return_value != 0 ) {
	free(return_value);
	return_value = 0;
	}

 while ( key_seek < branch_end ) {
	for ( line = key_seek ; *key_seek != '\n' && key_seek < branch_end ; key_seek++ );
	while ( isspace(*line) && line < key_seek ) line++;
	if ( isalpha(*line) ) {
		if ( memcmp(line, k_name, k_len) == 0 ) {
			line += k_len;
			while ( isspace(*line) && line < key_seek ) line++;
			if ( *line == '=' ) {
				line++;
				while ( isspace(*line) && line < key_seek ) line++;
				while ( isspace(*key_seek) && key_seek > line ) key_seek--;
				key_seek++;
				
				r_len = key_seek - line;
				return_value = malloc(r_len + 1);
				memcpy(return_value, line, r_len);
				*(return_value + r_len) = 0;
				break;
				}
			}
		}
	key_seek++;
	}
 return return_value;
}
