/*
 * dProxy2 - Copyright (c) dark0n3 2001 - 2002
 *
 */



#define FORK		1
#define SEND_KEEPALIVE	1
#define	MAX_CONNECTIONS	512
#define BUF_SIZE	1024
#define VERSION		"2.020313"

/*
 * Setting BUF_SIZE < 512 causes memleaks
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/time.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <resolv.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <resolv.h>
#include <stdarg.h>
#include <openssl/ssl.h>
#include <openssl/x509v3.h>
#include <openssl/err.h>
#include <openssl/bio.h>
#include <openssl/rand.h>
#include "../include/config-reader.h"
#include "../include/ip-check.h"
#include "../include/crypt.h"

static char copyright[] = "Copyright (c) dark0n3 2001 - 2002 <d@stoke.sillanpaa.jyu.fi>";



struct _ADDR {
 char		host[256];
 unsigned	port;
};


struct _PASV_ADDR {
 char		host[4];
 unsigned	port;
};



struct _CONN {
 SSL		*ssl;
 SSL_CTX	*ssl_ctx;
 int		user_sock;
 int		server_sock;

 uid_t		uid;

 unsigned char	status;
 unsigned char	type;

 struct _PASV_ADDR	pasv;
 struct _ADDR		target;

 unsigned char	cache_len;
 unsigned char	user[256];
 unsigned char	cache[255];
 unsigned char	user_host[4];
};


struct _CONFIG {
 char		*file;
 char		*log_file;
 unsigned	ftp_listen_port;
 unsigned	ssl_listen_port;
 unsigned char	auth;
};



struct _CONFIG		config;
struct _CONN		conn[MAX_CONNECTIONS];
int			ftp_entry_sock = -1;
int			ssl_entry_sock = -1;



#define DISCONNECTED		0
#define WAIT_SOCKS_HELLO	1
#define WAIT_AUTH		2
#define WAIT_COMMAND		3
#define WAIT_CONNECTION		4
#define ACTIVE			5

#define TYPE_FTP		1
#define TYPE_NORMAL		2
#define TYPE_SSL		3

#define LOG_CLIENT_CONNECTION	0
#define LOG_SERVER_CONNECTION	1
#define LOG_DEBUG		2
#define LOG_ERROR		255










/*
 * void log(int logtype, char *format, ...);
 *
 * Appends stuff to LOGFILE
 *
 */
void log(int logtype, char *fmt, ...) {
 time_t         timenow;
 FILE           *file;
 va_list        ap;

 va_start(ap, fmt);
 timenow = time(NULL);

 if ((file = fopen(config.log_file, "a+")) != NULL ) {
	fprintf(file, "%.24s - ", ctime(&timenow));
	vfprintf(file, fmt, ap);
	fclose(file);
	}            
}










/*
 * int ssl_connect(unsigned cnum)
 *
 * Tries to open SSL encrypted connection
 *
 */
int ssl_connect(unsigned cnum) {
 SSL_CTX	*ssl_ctx;

 conn[cnum].ssl_ctx = ssl_ctx = SSL_CTX_new(SSLv3_client_method());

 if ( !ssl_ctx ) {
	log(LOG_ERROR, "[%s:%u] Certification creation failed\n", conn[cnum].user, cnum);
	return 1;
	}

 SSL_CTX_set_options(ssl_ctx, SSL_OP_ALL);
 SSL_CTX_set_default_verify_paths(ssl_ctx);
 SSL_CTX_set_session_cache_mode(ssl_ctx, SSL_SESS_CACHE_CLIENT);

 conn[cnum].ssl = SSL_new(ssl_ctx);
 SSL_set_fd(conn[cnum].ssl, conn[cnum].server_sock);

 switch ( SSL_connect(conn[cnum].ssl) ) {
	case 1:
		log(LOG_SERVER_CONNECTION, "[%s:%u] SSL connection succesful\n", conn[cnum].user, cnum);
		return 0;
		break;
	default:
		log(LOG_SERVER_CONNECTION, "[%s:%u] SSL connection failed\n", conn[cnum].user, cnum);
		return -1;
		break;
	}
}










/*
 * void kill_connection(unsigned cnum)
 *
 * Kills connection and frees allocated memory
 *
 */
void kill_connection(unsigned cnum) {
 if ( *conn[cnum].user != 0 ) {
	log(LOG_CLIENT_CONNECTION, "[%s:%u] Disconnecting client and server\n", conn[cnum].user, cnum);
	} else {
	log(LOG_CLIENT_CONNECTION, "[unknown:%u] Disconnecting client and server\n", cnum);
	}

 if ( conn[cnum].ssl_ctx != 0 ) {
	SSL_CTX_free(conn[cnum].ssl_ctx);
	}

 if ( conn[cnum].ssl != 0 ) {
	SSL_shutdown(conn[cnum].ssl);
	SSL_free(conn[cnum].ssl);
	}

 if ( conn[cnum].server_sock > 0 ) {
	close(conn[cnum].server_sock);
	}

 if ( conn[cnum].user_sock > 0 ) {
	close(conn[cnum].user_sock);
	}

 bzero(&conn[cnum].pasv, sizeof(struct _PASV_ADDR));
 bzero(&conn[cnum].target, sizeof(struct _ADDR));
 bzero(&conn[cnum], sizeof(struct _CONN));
}










/*
 * int my_server_read(unsigned cnum, void *buf, size_t count)
 *
 * Reads ssl encrypted data from server_sock
 *
 */
ssize_t my_server_read(unsigned cnum, void *buf, size_t count) {
 ssize_t	c;

 if ( conn[cnum].ssl == 0 ) {
	c = read(conn[cnum].server_sock, buf, count);
	} else {
	c = SSL_read(conn[cnum].ssl, buf, count);
	}
 return c;
}










/*
 * int my_server_write(unsigned cnum, void *buf, size_t count)
 *
 * Writes ssl encrypted data to server_sock
 *
 */
ssize_t my_server_write(unsigned cnum, void *buf, size_t count) {
 ssize_t	c;

 if ( conn[cnum].ssl == 0 ) {
	c = write(conn[cnum].server_sock, buf, count);
	} else {
	c = SSL_write(conn[cnum].ssl, buf, count);
	}
 return c;
}










/*
 * void catch_cmd(unsigned char *buf, unsigned b_size, unsigned cnum)
 *
 * Looks for certain events
 *
 */
void catch_cmd(unsigned char *buf, unsigned b_size, unsigned cnum) {
 unsigned char	pasv_value[6];
 char		pasv_reply[] = { '(' , ',' , ',' , ',' , ',' , ',' , ')' };
 char		*line_end;
 char		*line;
 char		*end;
 char		*cache;
 char		*var;
 char		*cache_end;
 unsigned char	n;
 int		l;

 line_end = line = buf;
 end = buf + b_size;

 while ( line_end < end ) {
	for ( line = line_end ; *line_end != '\n' && line_end < end ; line_end++ );

	n = (255 - conn[cnum].cache_len > line_end - line ? line_end - line : 255 - conn[cnum].cache_len);

	memcpy(conn[cnum].cache + conn[cnum].cache_len, line, n);
	conn[cnum].cache_len += n;

	if ( *line_end == '\n' ) {
		if ( ! memcmp(conn[cnum].cache, "227 ", 4) ) {

				/* PASV - cache pasv ip/port */

			cache = conn[cnum].cache;
			cache_end = conn[cnum].cache + conn[cnum].cache_len;
			for ( n = 0 ; n < 7 ; n++ ) {
				for ( var = cache ; *cache != *(pasv_reply + n) && cache < cache_end ; cache++ );
				
				if ( *cache == *(pasv_reply + n) ) {
					if ( n > 0 ) {
						*cache = 0;
						*(pasv_value + n - 1) = atoi(var);
						}
					} else {
					bzero(pasv_value, 6);
					break;
					}
				cache++;
				}
			memcpy(conn[cnum].pasv.host, pasv_value, 4);
			conn[cnum].pasv.port = (pasv_value[4] << 8) + pasv_value[5];
			} else if ( ! memcmp(conn[cnum].cache, "220 ", 4) ) {

				/* WELCOME MESSAGE - try TLS */

			write(conn[cnum].server_sock, "AUTH TLS\r\n", 10);
			read(conn[cnum].server_sock, conn[cnum].cache, 255);

			if ( *conn[cnum].cache == '2' ) {
				if ( ssl_connect(cnum) != 0 ) {
					kill_connection(cnum);
					return;
					}
				}
			}
		conn[cnum].cache_len = 0;
		bzero(conn[cnum].cache, 255);
		}
	line_end++;
	}
}










/*
 * int get_config()
 *
 * Reads server settings from config
 *
 */
int get_config() {
 char		*key;

 if ( open_config(config.file) != 0 ) {
	printf("Fatal: Config file does not exist! [%s]\n\n", config.file);
	return 2;
	}

 if ( seek_config_branch("global") != 0 ) {
	printf("Fatal: Could not find 'global' branch from config!\n\n");
	return 2;
	}

 if ((key = seek_config_key("tls port")) == 0) {
	printf("Fatal: Could not find key 'tls port' from global branch!\n\n");
	return 2;
	}
 config.ftp_listen_port = atoi(key);

 if ((key = seek_config_key("ssl port")) == 0) {
	printf("Fatal: Could not find key 'ssl port' from global branch!\n\n");
	return 2;
	}
 config.ssl_listen_port = atoi(key);

 if ( config.ssl_listen_port == 0 && config.ftp_listen_port == 0 ) {
	printf("Fatal: Boths listen ports disabled\n\n");
	return 2;
	}

 if ( config.ssl_listen_port == config.ftp_listen_port ) {
	printf("Fatal: 'tls port' and 'ssl port' may not have same value\n\n");
	return 2;
	}

 if ((key = seek_config_key("user authentication")) == 0) {
	printf("Fatal: Could not find key 'user authentication' from global branch!\n\n");
	return 2;
	}

 if ( ! strcasecmp(key, "enabled")) {
	config.auth = 1;
	} else {
	config.auth = 0;
	}

 if ((key = seek_config_key("log file")) == 0) {
	printf("Fatal: Could not find key 'log file' from global branch!\n\n");
	return 2;
	}
 config.log_file = malloc(strlen(key) + 1);
 memcpy(config.log_file, key, strlen(key) + 1);

 return 0;
}










/*
 * void quit(int error)
 *
 * Frees allocated memory and quits.
 *
 */
void quit(int error) {

 free(config.log_file);
 if ( ftp_entry_sock != -1 ) {
	close(ftp_entry_sock);
	}
 if ( ssl_entry_sock != -1 ) {
	close(ssl_entry_sock);
	}
 close_config();

 exit(error);
}










/*
 * Main loop
 *
 */
int main (int argc, char **argv) {
 struct sockaddr_in	ftp_local, ssl_local, remote, local;
 struct hostent		*hp;
 int			no_signal = 1;
 fd_set			read_ds, write_ds;
 int			n, s, l, m;
 int			b_fd = -1;
 int			p_fd = -1;
 unsigned		sz;
 unsigned char		buf[BUF_SIZE];
 char			*key;

 printf("\ndProxy2 - %s\n\n", copyright);

/* SSL_load_error_strings(); */
 SSLeay_add_ssl_algorithms();

 if ( argc > 2 ) {
	printf("Usage: %s [config file]\n\n", argv[0]);
	return 0;
	} else if ( argc == 2 ) {
	config.file = argv[1];
	} else {
	config.file = "/etc/dproxy.conf";
	}

 if ( get_config() != 0 ) {
	quit(2);
	}

 sz = sizeof(struct sockaddr_in);

 bzero(&conn, sizeof(struct _CONN) * MAX_CONNECTIONS);
 bzero(&ssl_local, sz);

	/* Bind to TLS port */

 if ( config.ftp_listen_port ) {
	bzero(&ftp_local, sz);
	ftp_local.sin_addr.s_addr = INADDR_ANY;
	ftp_local.sin_family = AF_INET;
	ftp_local.sin_port = htons(config.ftp_listen_port);
	ftp_entry_sock = socket(PF_INET, SOCK_STREAM, 0);
	if ( bind(ftp_entry_sock, (struct sockaddr *)&ftp_local, sz) != 0 ) {
		printf("Fatal: Could not bind to TLS port!\n\n");
		quit(2);
		} else {
		listen(ftp_entry_sock, 1024);
		p_fd = ftp_entry_sock;
		}
	}

	/* Bind to SSL port */


 if ( config.ssl_listen_port ) {
	ssl_local.sin_addr.s_addr = INADDR_ANY;
	ssl_local.sin_port = htons(config.ssl_listen_port);
	ssl_local.sin_family = AF_INET;
	ssl_entry_sock = socket(PF_INET, SOCK_STREAM, 0);
	if ( bind(ssl_entry_sock, (struct sockaddr *)&ssl_local, sz) != 0 ) {
		printf("Fatal: Could not bind to SSL port!\n\n");
		quit(2);
		} else {
		listen(ssl_entry_sock, 1024);
		p_fd = (p_fd > ssl_entry_sock ? p_fd : ssl_entry_sock);
		}
	}

 if ( ftp_entry_sock != -1 ) {
		printf("TLS proxy on port: %u\n", config.ftp_listen_port);
		}
 if ( ssl_entry_sock != -1 ) {
		printf("SSL proxy on port: %u\n", config.ssl_listen_port);
		}


#if ( FORK == 1 )
 if ( fork() ) {
	printf("\n");
	exit(0);
	}
#endif

 while ( no_signal ) {
	FD_ZERO(&read_ds);
	FD_ZERO(&write_ds);
	if ( ftp_entry_sock != -1 ) {
		FD_SET(ftp_entry_sock, &read_ds);
		}
	if ( ssl_entry_sock != -1 ) {
		FD_SET(ssl_entry_sock, &read_ds);
		}

	b_fd = p_fd;

		/* Listen for open sockets */

	for ( n = 0 ; n < MAX_CONNECTIONS ; n++ ) {
		if ( conn[n].status != DISCONNECTED ) {
			FD_SET(conn[n].user_sock, &read_ds);

			if ( conn[n].status == ACTIVE ) {
				FD_SET(conn[n].server_sock, &read_ds);
				if ( conn[n].user_sock > conn[n].server_sock ) {
					b_fd = conn[n].user_sock > b_fd ? conn[n].user_sock : b_fd;
					} else {
					b_fd = conn[n].server_sock > b_fd ? conn[n].server_sock : b_fd;
					}
				} else if ( conn[n].status == WAIT_CONNECTION ) {
				FD_SET(conn[n].server_sock, &write_ds);
				if ( conn[n].user_sock > conn[n].server_sock ) {
					b_fd = conn[n].user_sock > b_fd ? conn[n].user_sock : b_fd;
					} else {
					b_fd = conn[n].server_sock > b_fd ? conn[n].server_sock : b_fd;
					}
				} else {
				b_fd = conn[n].user_sock > b_fd ? conn[n].user_sock : b_fd;
				}
			}
		}

		/* Wait for data arrive / user connect */

	select(b_fd + 1, &read_ds, &write_ds, 0, 0);

		/* User connects through ftp port */

	if ( ftp_entry_sock != -1 && FD_ISSET(ftp_entry_sock, &read_ds) ) {
		bzero(&remote, sz);
		s = accept(ftp_entry_sock, (struct sockaddr *)&remote, &sz);

		for ( n = 0 ; n < MAX_CONNECTIONS ; n++ ) {
			if ( conn[n].status == DISCONNECTED ) {
				break;
				}
			}
		if ( conn[n].status == DISCONNECTED ) {
#if ( SEND_KEEPALIVE )
			l = 1;
			setsockopt(s, SOL_SOCKET, SO_KEEPALIVE, &l, sizeof(int));
#endif
			conn[n].type = TYPE_FTP;
			conn[n].user_sock = s;
			conn[n].status = WAIT_SOCKS_HELLO;
			memcpy(conn[n].user_host, &remote.sin_addr, 4);
			log(LOG_CLIENT_CONNECTION, "[unknown:%u] New client connected to TLS port from %u.%u.%u.%u\n", n, conn[n].user_host[0], conn[n].user_host[1], conn[n].user_host[2], conn[n].user_host[3]);
			} else {
			log(LOG_CLIENT_CONNECTION, "Maximum number of clients already connected - dropping client\n");
			close(s);
			}
		}

		/* User connects through ssl port */

	if ( ssl_entry_sock != -1 && FD_ISSET(ssl_entry_sock, &read_ds) ) {
		bzero(&remote, sz);
		s = accept(ssl_entry_sock, (struct sockaddr *)&remote, &sz);

		for ( n = 0 ; n < MAX_CONNECTIONS ; n++ ) {
			if ( conn[n].status == DISCONNECTED ) {
				break;
				}
			}
		if ( conn[n].status == DISCONNECTED ) {
#if ( SEND_KEEPALIVE )
			l = 1;
			setsockopt(s, SOL_SOCKET, SO_KEEPALIVE, &l, sizeof(int));
#endif
			conn[n].type = TYPE_SSL;
			conn[n].user_sock = s;
			conn[n].status = WAIT_SOCKS_HELLO;
			memcpy(conn[n].user_host, &remote.sin_addr, 4);
			log(LOG_CLIENT_CONNECTION, "[unknown:%u] New client connected to SSL port from %u.%u.%u.%u\n", n, conn[n].user_host[0], conn[n].user_host[1], conn[n].user_host[2], conn[n].user_host[3]);
			} else {
			log(LOG_CLIENT_CONNECTION, "Maximum number of clients already connected - dropping client\n");
			close(s);
			}
		}

		/* Read incoming data */

	for ( n = 0 ; n < MAX_CONNECTIONS ; n++ ) {
		if ( conn[n].status != DISCONNECTED ) {
			if ( conn[n].status == ACTIVE ) {

					/* Data coming from user */

				if ( FD_ISSET(conn[n].user_sock, &read_ds) ) {
					if ((l = read(conn[n].user_sock, buf, BUF_SIZE)) <= 0 ||
					    my_server_write(n, buf, l) != l ) {
						kill_connection(n);
						continue;
						}
					}

					/* Data coming from server */

				if ( FD_ISSET(conn[n].server_sock, &read_ds) ) {
					if ((l = my_server_read(n, buf, BUF_SIZE)) <= 0 ||
					    write(conn[n].user_sock, buf, l) != l ) {
						kill_connection(n);
						continue;
						} else {
						if ( conn[n].type == TYPE_FTP ) {
							catch_cmd(buf, l, n);
							}
						}
					}
				} else if ( conn[n].status == WAIT_CONNECTION ) {

					/* Client should not send anything here - kill if he does */

				if ( FD_ISSET(conn[n].user_sock, &read_ds) ) {
					kill_connection(n);
					} else if ( FD_ISSET(conn[n].server_sock, &write_ds) ) {

					/* Server socket state has changed */

					conn[n].status = ACTIVE;
					*buf = 5;
					*(buf + 2) = 0;
					l = sizeof(s);
					getsockopt(conn[n].server_sock, SOL_SOCKET, SO_ERROR, &s, &l);

					switch ( s ) {
						case 0:
							fcntl(conn[n].server_sock, F_SETFL, 0);
							*(buf + 1) = 0;
							if ( conn[n].type == TYPE_SSL ) {
								if ( ssl_connect(n) != 0 ) {
									*(buf + 1) = 1;
									}
								}
							break;
						case ENETUNREACH:
							*(buf + 1) = 3;
							break;
						case ECONNREFUSED:
							*(buf + 1) = 5;
							break;
						case ETIMEDOUT:
							*(buf + 1) = 6;
							break;
						default:
							*(buf + 1) = 1;
							break;
						}

					if ( *conn[n].cache > 0 ) {
						*(buf + 3) = 1;
						l = 4;
						memcpy(buf + 4, conn[n].cache, l);
						} else {
						*(buf + 3) = 3;
						l = strlen(conn[n].target.host);
						*(buf + 4) = l;
						memcpy(buf + 5, conn[n].target.host, l);
						}

					memcpy(buf + l + 4, &conn[n].target.port, 2);

					if ( write(conn[n].user_sock, buf, 6 + l) != 6 + l || *(buf + 1) != 0 ) {
						kill_connection(n);
						}
					}
				} else {
				if ( FD_ISSET(conn[n].user_sock, &read_ds) ) {

					/* Check for socks5 compatible data */

					bzero(buf, BUF_SIZE);
					s = read(conn[n].user_sock, buf, BUF_SIZE);
					if ( s > 0 ) {
						switch ( conn[n].status ) {
							case WAIT_SOCKS_HELLO:
								if ( *buf == 5 ) {
									if ( config.auth == 0 ) {
										*(buf + 1) = 0;
										conn[n].status = WAIT_COMMAND;
										memcpy(conn[n].user, "unknown", 8);
										} else {
										*(buf + 1) = 2;
										conn[n].status = WAIT_AUTH;
										}
									write(conn[n].user_sock, buf, 2);
									} else {
									kill_connection(n);
									}
								break;
							case WAIT_AUTH:
								if ( *buf == 1 ) {
									l = *(buf + 1);
									s = 1;
									sprintf(conn[n].user, "%.*s", l, buf + 2);
									if ( seek_config_branch(conn[n].user) == 0 ) {
										if ((key = seek_config_key("password")) != 0 ) {
											if ( passcmp(key, buf + l + 3, *(buf + l + 2)) == 0) {
												s = 0;
												}
											} else {
											s = 0;
											}

										if (s == 0 && (key = seek_config_key("uid")) != 0 ) {
											conn[n].uid = atoi(key);
											}

										if (s == 0 && (key = seek_config_key("hosts allow")) != 0) {
											sprintf(buf, "%u.%u.%u.%u", conn[n].user_host[0], conn[n].user_host[1], conn[n].user_host[2], conn[n].user_host[3]);
											if ( ip_check(buf, key) == 0 ) {
												s = 2;
												}
											}
										} else {
										s = 3;
										}
									*buf = 5;
									*(buf + 1) = s;
									write(conn[n].user_sock, buf, 2);
									switch ( s ) {
										case 0:
											conn[n].status = WAIT_COMMAND;
											break;
										case 1:
											log(LOG_CLIENT_CONNECTION, "[%s:%u] Client authentication failed (invalid pass)\n", conn[n].user, n);
											kill_connection(n);
											break;
										case 2:
											log(LOG_CLIENT_CONNECTION, "[%s:%u] Client authentication failed (invalid ip)\n", conn[n].user, n);
											kill_connection(n);
											break;
										case 3:
											log(LOG_CLIENT_CONNECTION, "[unknown:%u] Client authentication failed (invalid login)\n", n);
											kill_connection(n);
											break;
										}
									} else {
									kill_connection(n);
									}
								break;
							case WAIT_COMMAND:
								if ( *buf == 5 && *(buf + 1) == 1 ) {
									bzero(&remote, sz);

									switch ( *(buf + 3) ) {
										case 1:
											l = 4;
											sprintf(conn[n].target.host, "%u.%u.%u.%u", *(buf + 4), *(buf + 5), *(buf + 6), *(buf + 7));
											memcpy(conn[n].cache, buf + 4, 4);
											memcpy(&remote.sin_addr, buf + 4, 4);
											break;
										case 3:
											l = *(buf + 4);
											memcpy(conn[n].target.host, buf + 5, l);
											bzero(conn[n].cache, 4);
											*(conn[n].target.host + l) = 0;
											l++;
											hp = gethostbyname(conn[n].target.host);
											memcpy(&remote.sin_addr, hp->h_addr, hp->h_length);
											break;
										}
									conn[n].target.port = (*(buf + l + 4) << 8) + *(buf + l + 5);

									remote.sin_family = AF_INET;
									remote.sin_port = htons((unsigned)conn[n].target.port);

									if ( conn[n].type == TYPE_FTP ) {
										for ( s = 0 ; s < MAX_CONNECTIONS ; s++ ) {
											if ( conn[s].status == ACTIVE && conn[s].pasv.host != 0 ) {
												if ( ! memcmp(conn[s].pasv.host, hp->h_addr, 4) && conn[n].target.port == conn[s].pasv.port ) {
													conn[n].type = TYPE_NORMAL;
													bzero(&conn[s].pasv, sizeof(struct _PASV_ADDR));
													break;
													}
												}
											}
										}

									if ( conn[n].uid != 0 && getuid() == 0 ) {
										seteuid(conn[n].uid);
										}

									l = socket(AF_INET, SOCK_STREAM, 0);

									if (seek_config_branch(conn[n].user) == 0) {
										if ((key = seek_config_key("bind ip")) != 0) {
											bzero(&local, sz);
											hp = gethostbyname(key);
											memcpy(&local.sin_addr, hp->h_addr, hp->h_length);
											local.sin_family = AF_INET;
											bind(l, (struct sockaddr *)&local, sz);
											}
										}

									fcntl(l, F_SETFL, O_NONBLOCK);
#if ( SEND_KEEPALIVE )
									s = 1;
									setsockopt(l, SOL_SOCKET, SO_KEEPALIVE, &s, sizeof(int));
#endif


									connect(l, (struct sockaddr *)&remote, sz);
									
									if ( conn[n].uid != 0 && getuid() == 0 ) {
										seteuid(0);
										}

									log(LOG_SERVER_CONNECTION, "[%s:%u] Client requested connection to %s:%u\n", conn[n].user, n, conn[n].target.host, conn[n].target.port);

									conn[n].server_sock = l;
									conn[n].status = WAIT_CONNECTION;
									} else {
									kill_connection(n);
									}
								break;
							}
						} else {
						kill_connection(n);
						}
					}
				}
			}
		}
	}
 quit(0);
}
